﻿Module Module1

    Sub Main()
        'Exemplo1()
        'Exemplo2()
        'Exemplo3()
        Exemplo4()
    End Sub
    Public Sub cabecalho(texto As String)
        Console.WriteLine("Macoratti .net")
        Console.WriteLine("--------------------------------------------------")
        Console.WriteLine(texto)
        Console.WriteLine("--------------------------------------------------")
        Console.WriteLine("")
    End Sub

    Public Sub Exemplo1()
        cabecalho("Lista Contatos com idade inferior a 45 anos")

        Dim contatos As List(Of Contato) = Contato.DadosTeste()

        Dim q = From c In contatos Where c.Nascimento.AddYears(45) > DateTime.Now Order By c.Nascimento Descending
                Select String.Format("{0} {1} , nascimento : {2}", c.Nome, c.Sobrenome, c.Nascimento.ToString("dd-MMM-yyyy"))

        For Each s As String In q
            Console.WriteLine(s)
        Next

        Console.ReadKey()
    End Sub

    Public Sub Exemplo2()
        cabecalho("Lista Contatos por Estado")

        Dim contatos As List(Of Contato) = Contato.DadosTeste()

        Dim consulta = From c In contatos Group c By c.Estado Into ContatosGrupo = Group

        For Each grupo In consulta
            Console.WriteLine("Estado : " + grupo.Estado)
            For Each c In grupo.ContatosGrupo
                Console.WriteLine(" {0} {1}", c.Nome, c.Sobrenome)
            Next
        Next

        Console.ReadKey()
    End Sub
    Public Sub Exemplo3()

        cabecalho("Consulta com junção de duas Coleções com base no numero do telefone")

        Dim contatos As List(Of Contato) = Contato.DadosTeste()
        Dim chamadas As List(Of LogChamadas) = LogChamadas.DadosTeste()

        Dim consulta = From ligacao In chamadas
                       Join contato In contatos On _
                       ligacao.Numero Equals contato.Telefone _
                       Select New With { _
                        contato.Nome, _
                        contato.Sobrenome, _
                        ligacao.Data, _
                        ligacao.Duracao _
                    }

        For Each c In consulta
            Console.WriteLine(" {0} – {1} {2} ({3} min)", c.Data.ToString("dd MMM HH:m"), c.Nome, c.Sobrenome, c.Duracao)
        Next

        Console.ReadKey()
    End Sub

    Public Sub Exemplo4()
        cabecalho("Resumo do log de ligações, filtrando, ordenando, agrupando, " & vbLf & "juntando e selecionando usando valores agregados")

        Dim contatos As List(Of Contato) = Contato.DadosTeste()
        Dim chamadas As List(Of LogChamadas) = LogChamadas.DadosTeste()

        Dim consulta = From ligacao In chamadas
                       Where ligacao.Recebida = True
                       Group ligacao By ligacao.Numero Into lig = Group
                       Join contato In contatos On
                          Numero Equals contato.Telefone
                       Order By contato.Nome, contato.Sobrenome
                       Select New With { _
                            contato.Nome, _
                            contato.Sobrenome, _
                            .Conta = lig.Count(), _
                            .Media = lig.Average(Function(c) c.Duracao), _
                            .Total = lig.Sum(Function(c) c.Duracao) _
                        }

        For Each ligacao In consulta
            Console.WriteLine("{0} {1} - ligações: {2}, Tempo: {3} mins, Média: {4} mins ", ligacao.Nome, ligacao.Sobrenome, ligacao.Conta, ligacao.Total, Math.Round(ligacao.Media, 2))
        Next
        Console.ReadKey()
    End Sub

End Module
